#include <allegro.h>
#include <stdio.h>
#include "vb_gui.h"
#include "vb_set.h"
#include "v810_cpu.h" //Needed for V810_MEMORYFETCH & V810_REGFETCH structs
#include "vb_vbt.h" //Needed for RAM addresses
#include "vb_types.h" //Needed for HWORD declaration
#include "vb_dsp.h"
#include "vb_dspD.h"
#include "port.h"

char *keynames[] = {
   "   ", " A ", " B ", " C ", " D ", " E ", " F ", " G ", " H ", " I ",
   " J ", " K ", " L ", " M ", " N ", " O ", " P ", " Q ", " R ", " S ",
   " T ", " U ", " V ", " W ", " X ", " Y ", " Z ", " 0 ", " 1 ", " 2 ",
   " 3 ", " 4 ", " 5 ", " 6 ", " 7 ", " 8 ", " 9 ", "0PD", "1PD", "2PD",
   "3PD", "4PD", "5PD", "6PD", "7PD", "8PD", "9PD", "F1 ", "F2 ", "F3 ",
   "F4 ", "F5 ", "F6 ", "F7 ", "F8 ", "F9 ", "F10", "F11", "F12", "ESC",
   " ~ ", " - ", " = ", "BKS", "TAB", " { ", " } ", "ENT", " : ", " \" ",
   " \\ ", " \\ ", " , ", " . ", " / ", "SPC", "INS", "DEL", "HOM", "END",
   "PGU", "PGD", "LFT", "RHT", "UP ", "DWN", "SPD", " * ", "-PD", "+PD",
   "DLP", "EPD", "PRT", "PAU", "ABN", "YEN", "KAN", "CON", "NCO", " @ ",
   "CRC", ":2 ", "KJI", "LSH", "RSH", "LCT", "RCT", "ALT", "ALG",
   "LWN", "RWN", "MNU", "SCR", "NUM", "CAP"
};

void change_color(int r, int g, int b);


int file_loadrom(void) {
  int ret;
 
  ret = file_select_ex("Load ROM:", rompath, "vb", 384, OLD_FILESEL_WIDTH, OLD_FILESEL_HEIGHT);
  
  if(ret) { 
   tVBOpt.ROM_NAME = rompath;
   setMenu(1,1,1);
   guiop = AKILL;
  }
}

int file_closerom(void) {
 setMenu(0,0,0);
 broadcast_dialog_message(MSG_DRAW, 0);

}


int file_exit(void)
{
     guiop = AKILL | GUIEXIT; 
     return D_EXIT;
}

int options_video(void)
{
   int c, w, h, depth;
   int ret, mode_failure;

   c = tVBOpt.SCR_MODE;
   w = tVBOpt.SCR_X;
   h = tVBOpt.SCR_Y;
   depth = 24;

   ret = gfx_mode_select_ex(&c, &w, &h, &depth);

   //Did they click "OK"?
   if (ret) {
//	   set_color_depth(depth);
	   mode_failure = set_gfx_mode(c, w, h, 0, 0);
           
	   tVBOpt.SCR_MODE = c;
	   tVBOpt.SCR_X = w;
	   tVBOpt.SCR_Y = h;

	   if (mode_failure) {
		   alert(e_modefail, NULL, NULL, b_ok, NULL, 1, (int)NULL);
		   printf("%s\n", e_modefail);
	   }
   }	   
}


int options_input(void) {
    doKeys();
}

int options_emulation(void) {
	doOptions();
}


int options_saveoptions(void) {

    int i=0;

    optionsFile = fopen("options.dat", "w");	
    if(optionsFile != 0) {
	  
      fprintf(optionsFile, "platform=");
      writeValue(platform);
      fprintf(optionsFile, "frmskip=");
      writeValue(tVBOpt.FRMSKIP);
      fprintf(optionsFile, "dspmode=");
      writeValue(tVBOpt.DSPMODE);
      fprintf(optionsFile, "dspswap=");
      writeValue(tVBOpt.DSPSWAP);
      fprintf(optionsFile, "palmod=");
      writeValue(tVBOpt.PALMODE);
      fprintf(optionsFile, "scrx=");
      writeValue(tVBOpt.SCR_X);
      fprintf(optionsFile, "scry=");
      writeValue(tVBOpt.SCR_Y);
     
      //Complex screenmode code ;-)
      fprintf(optionsFile, "scrmode=");
      for(i=0;i<drivercount;i++) {
         if(tVBOpt.SCR_MODE == VBgfx_driver[i]) { writeValue(i); }
      }
      
      fprintf(optionsFile, "lu=");
      writeValue(vbkey[0]);
      fprintf(optionsFile, "ld=");
      writeValue(vbkey[1]);
      fprintf(optionsFile, "ll=");
      writeValue(vbkey[2]);
      fprintf(optionsFile, "lr=");
      writeValue(vbkey[3]);
      fprintf(optionsFile, "ru=");
      writeValue(vbkey[4]);
      fprintf(optionsFile, "rd=");
      writeValue(vbkey[5]);
      fprintf(optionsFile, "rl=");
      writeValue(vbkey[6]);
      fprintf(optionsFile, "rr=");
      writeValue(vbkey[7]);

      fprintf(optionsFile, "ba=");
      writeValue(vbkey[8]);
      fprintf(optionsFile, "bb=");
      writeValue(vbkey[9]);
      fprintf(optionsFile, "st=");
      writeValue(vbkey[10]);
      fprintf(optionsFile, "sl=");
      writeValue(vbkey[11]);
      fprintf(optionsFile, "tl=");
      writeValue(vbkey[12]);
      fprintf(optionsFile, "tr=");
      writeValue(vbkey[13]);


      fclose(optionsFile);
    }
    else { 
	    printf("%s\n", e_file);
	    alert(e_file, NULL, NULL, b_ok, NULL, 1, (int)NULL);
    }       
}


int emulation_resume(void) {
  guiop = AKILL;
  setMenu(1,1,1);

  return D_EXIT;
}

int emulation_sstate(void) {
   int i;
   int highbyte;
   int lowbyte;
   int ret;
        
   ret = file_select_ex("Save State:", sspath, "vbs", 384, OLD_FILESEL_WIDTH, OLD_FILESEL_HEIGHT);

   if(ret) {
        stateFile = fopen(sspath, "wb");

	if(stateFile==NULL) {
	   alert("Error creating file!", "Check that you have permission to write", NULL, b_ok, NULL, 1, (int)NULL); 
	   return 0;
	}

	//Write the VIP registers first (could be done better!)
	writeHWORD(vipcreg_rhword(0x0005F800));	
	writeHWORD(vipcreg_rhword(0x0005F802));
	writeHWORD(vipcreg_rhword(0x0005F820));
  	writeHWORD(vipcreg_rhword(0x0005F822));
	writeHWORD(vipcreg_rhword(0x0005F824));
	writeHWORD(vipcreg_rhword(0x0005F826));
	writeHWORD(vipcreg_rhword(0x0005F828));
	writeHWORD(vipcreg_rhword(0x0005F82A));
	writeHWORD(vipcreg_rhword(0x0005F82E));
	writeHWORD(vipcreg_rhword(0x0005F830));
	writeHWORD(vipcreg_rhword(0x0005F840));
	writeHWORD(vipcreg_rhword(0x0005F842));
	writeHWORD(vipcreg_rhword(0x0005F844));
	writeHWORD(vipcreg_rhword(0x0005F848));	
	writeHWORD(vipcreg_rhword(0x0005F84A));
	writeHWORD(vipcreg_rhword(0x0005F84C));
  	writeHWORD(vipcreg_rhword(0x0005F84E));
	writeHWORD(vipcreg_rhword(0x0005F860));
	writeHWORD(vipcreg_rhword(0x0005F864));
	writeHWORD(vipcreg_rhword(0x0005F866));
	writeHWORD(vipcreg_rhword(0x0005F868));
	writeHWORD(vipcreg_rhword(0x0005F86A));
	writeHWORD(vipcreg_rhword(0x0005F86C));
	writeHWORD(vipcreg_rhword(0x0005F86E));
	writeHWORD(vipcreg_rhword(0x0005F870));
	
	//Write hardware control registers
	for(i=0x02000000;i<=0x02000028;i=i+4) {
		fputc(hcreg_rbyte(i), stateFile);
	}	


	//Next we write all the RAM contents
	for(i=V810_DISPLAY_RAM.lowaddr;i<=V810_DISPLAY_RAM.highaddr;i++) {
		fputc((char)mem_rbyte(i), stateFile);
	}
	for(i=V810_SOUND_RAM.lowaddr;i<=V810_SOUND_RAM.highaddr;i++) {
		fputc((char)mem_rbyte(i), stateFile);
	}
	for(i=V810_VB_RAM.lowaddr;i<=V810_VB_RAM.highaddr;i++) {
		fputc((char)mem_rbyte(i), stateFile);
	}
	for(i=V810_GAME_RAM.lowaddr;i<=V810_GAME_RAM.highaddr;i++) {
		fputc((char)mem_rbyte(i), stateFile);
	}
	fclose(stateFile);
    }	
}

int emulation_lstate(void) {
   int i;
   int ret;

   ret = file_select_ex("Load State:", sspath, "vbs", 384, OLD_FILESEL_WIDTH, OLD_FILESEL_HEIGHT);

   if(ret) {
        stateFile = fopen(sspath, "rb");

        if(stateFile==NULL) {
           alert("Error reading file!", "Check that it still exists", NULL, b_ok, NULL, 1, (int)NULL); 
	   return 0;
        }        

	//Load VIP registers
	vipcreg_whword(0x0005F800, readHWORD());
	vipcreg_whword(0x0005F802, readHWORD());
	vipcreg_whword(0x0005F820, readHWORD());
	vipcreg_whword(0x0005F822, readHWORD());
	vipcreg_whword(0x0005F824, readHWORD());
	vipcreg_whword(0x0005F826, readHWORD());
	vipcreg_whword(0x0005F828, readHWORD());
	vipcreg_whword(0x0005F82A, readHWORD());
	vipcreg_whword(0x0005F82E, readHWORD());
	vipcreg_whword(0x0005F830, readHWORD());
	vipcreg_whword(0x0005F840, readHWORD());
	vipcreg_whword(0x0005F842, readHWORD());
	vipcreg_whword(0x0005F844, readHWORD());
	vipcreg_whword(0x0005F848, readHWORD());
	vipcreg_whword(0x0005F84A, readHWORD());
	vipcreg_whword(0x0005F84C, readHWORD());
	vipcreg_whword(0x0005F84E, readHWORD());
	vipcreg_whword(0x0005F860, readHWORD());
	vipcreg_whword(0x0005F864, readHWORD());
	vipcreg_whword(0x0005F866, readHWORD());
	vipcreg_whword(0x0005F868, readHWORD());
	vipcreg_whword(0x0005F86A, readHWORD());
	vipcreg_whword(0x0005F86C, readHWORD());
	vipcreg_whword(0x0005F86E, readHWORD());
	vipcreg_whword(0x0005F870, readHWORD());

	//Load hardware control registers
	for(i=0x02000000;i<=0x02000028;i=i+4) {
		hcreg_wbyte(i, fgetc(stateFile));
	}
	
	//Load the RAM
	for(i=V810_DISPLAY_RAM.lowaddr;i<=V810_DISPLAY_RAM.highaddr;i++) {
		mem_wbyte(i, fgetc(stateFile));
	}
	for(i=V810_SOUND_RAM.lowaddr;i<=V810_SOUND_RAM.highaddr;i++) {
		mem_wbyte(i, fgetc(stateFile));
	}
	for(i=V810_VB_RAM.lowaddr;i<=V810_VB_RAM.highaddr;i++) {
		mem_wbyte(i, fgetc(stateFile));
	}
	for(i=V810_GAME_RAM.lowaddr;i<=V810_GAME_RAM.highaddr;i++) {
		mem_wbyte(i, fgetc(stateFile));
	}
	
	fclose(stateFile);
    }
}

int debug_showinfo(void) {
    char romstring1[64];
    char romstring2[64];
    char romstring3[64];
    char romtitle[16];
    int manufacturer;
    int version;
    char id[4];
    int i;

    for(i=0;i<16;i++) {
       romtitle[i] = (char)mem_rbyte(0x07FFFDE0+i);
       //Get rid of any weird characers that might make the emu crash
       if( ((int)romtitle[i]<32) || ((int)romtitle[i]>126) ) { romtitle[i] = (char)32; }
    }

    manufacturer = (mem_rbyte(0x07FFFDF9)<<8) + mem_rbyte(0x07FFFDFA);
    for(i=0;i<4;i++) { id[i] = mem_rbyte(0x07FFFDFB+i); }
    version = mem_rbyte(0x07FFFDFF);
    
    sprintf(romstring1, "Title: %s", romtitle);
    sprintf(romstring2, "Manufacturer: 0x%x", manufacturer);
    sprintf(romstring3, "Game ID: %c%c%c%c Version: 0x%x", id[0], id[1], id[2], id[3], version);
    alert(romstring1, romstring2, romstring3, b_ok, NULL, 1, (int)NULL);

}

int debug_reset(void) {
    guiop = AKILL | VBRESET;
    return D_EXIT;
}

int debug_view_memory(void) { V810_DSP_Ram(); }
int debug_view_chars(void)  { V810_DSP_Chr(); }
int debug_view_bgmaps(void) { V810_DSP_BGMap(); }
int debug_view_worlds(void) { V810_DSP_World(); }

int debug_saveram(void)
{
     long i;
/*     printf("Display Low: 0x%x High: 0x%x", V810_DISPLAY_RAM.lowaddr,
         V810_DISPLAY_RAM.highaddr);
     printf("Sound Low: 0x%x High: 0x%x", V810_SOUND_RAM.lowaddr,
         V810_SOUND_RAM.highaddr);
     printf("VB Low: 0x%x High: 0x%x", V810_VB_RAM.lowaddr,
         V810_VB_RAM.highaddr);
     printf("Game Low: 0x%x High: 0x%x", V810_GAME_RAM.lowaddr,
         V810_GAME_RAM.highaddr);*/
     

        for(i=V810_DISPLAY_RAM.lowaddr;i<=V810_DISPLAY_RAM.highaddr;i=i+4) {
                //mem_rbyte(0x07FFFDFF);
                //mem_wbyte(i, fgetc(stateFile));
                if(i<=0xF) { printf("0x0000 000%x\n", i); }
                else if(i<=0xFF) { printf("0x000000%x\n", i); }
                else if(i<=0xFFF) { printf("0x00000%x\n", i); }
                else if(i<=0xFFFF) { printf("0x0000%x\n", i); }
                else if(i<=0xFFFFF) { printf("0x000%x\n", i); }
                else if(i<=0xFFFFFF) { printf("0x00%x\n", i); }
                else if(i<=0xFFFFFFF) { printf("0x0%x\n", i); }
                else if(i<=0xFFFFFFFF) { printf("0x%x\n", i); }
       }
/*        for(i=V810_SOUND_RAM.lowaddr;i<=V810_SOUND_RAM.highaddr;i++) {
		mem_wbyte(i, fgetc(stateFile));
	}
	for(i=V810_VB_RAM.lowaddr;i<=V810_VB_RAM.highaddr;i++) {
		mem_wbyte(i, fgetc(stateFile));
	}
	for(i=V810_GAME_RAM.lowaddr;i<=V810_GAME_RAM.highaddr;i++) {
		mem_wbyte(i, fgetc(stateFile));
        }         */
}

int help_about(void) {
  alert(m_about1, m_about2, m_about3, b_ok, NULL, 1, (int)NULL);
}

MENU debug_view_menu[] =
{
   { "&Memory", debug_view_memory, NULL, 0, NULL },
   { "&Chars", debug_view_chars, NULL, 0, NULL },
   { "&BGMaps", debug_view_bgmaps, NULL, 0, NULL },
//   { "&Worlds", debug_view_worlds, NULL, 0, NULL },
//   { "&OBJs", V810_DSP_Obj, NULL, 0, NULL }, 
   { NULL, NULL, NULL, 0, NULL }
};


MENU file_menu[] =
{
   { "&Load ROM",      file_loadrom,  NULL, 0,          NULL },
   { "&Close ROM",     file_closerom, NULL, D_DISABLED, NULL },
   { "",               NULL,          NULL, 0,          NULL },
   { "E&xit\tCtrl-X",  file_exit,     NULL, 0,          NULL },
   { NULL,             NULL,          NULL, 0,          NULL }
};


MENU options_menu[] =
{
   { "&Video", options_video, NULL, 0, NULL },
   { "&Input", options_input, NULL, 0, NULL },
   { "&Emulation", options_emulation, NULL, 0, NULL },
   { "", NULL, NULL, 0, NULL },
   { "&Save Options", options_saveoptions, NULL, 0, NULL },
   { NULL,     NULL,       NULL,  0, NULL }
};

MENU emulation_menu[] =
{
   { "&Resume Emulation", emulation_resume, NULL, 0, NULL },
   { "&Save State", emulation_sstate, NULL, 0, NULL },
   { "Loa&d State", emulation_lstate, NULL, 0, NULL },
   { NULL, NULL, NULL, 0, NULL }
};

MENU debug_menu[] =
{
   { "S&how ROM Info", debug_showinfo, NULL, 0, NULL },
   { "&Reset System", debug_reset, NULL, 0, NULL },
   { "&View", NULL, debug_view_menu, 0, NULL },
//   { "&Write RAM to File", debug_saveram, NULL, 0, NULL },
   { NULL, NULL, NULL, 0, NULL }
};



MENU help_menu[] =
{
   { "&About", help_about, NULL, 0, NULL },
   { NULL, NULL, NULL, 0, NULL }
};

MENU main_menu[] =
{
   { "&File", NULL, file_menu, 0, NULL },
   { "&Options", NULL, options_menu, 0, NULL },
   { "&Emulation", NULL, emulation_menu, D_DISABLED, NULL },
   { "&Debug", NULL, debug_menu, D_DISABLED, NULL },
   { "&Help", NULL, help_menu, 0, NULL },
   { NULL,    NULL, NULL,      0, NULL }
};








#define ctrl(x)      (x - 'a' + 1)

DIALOG main_dialog[] =
{
   { d_clear_proc,    0,    0,    640,  480,  0,    0,    0,         0,      0,   0,   NULL },
   { d_menu_proc,     0,    0,    0,    0,    0,    0,    0,         0,      0,   0,   main_menu },
   { d_keyboard_proc, 0,    0,    0,    0,    0,    0,    ctrl('x'), 0,      0,   0,   file_exit },
   { NULL,            0,    0,    0,    0,    0,    0,    0,         0,      0,   0,   NULL }
};

DIALOG input_dialog[] =
{
 { d_shadow_box_proc, 5, 20, 305, 160,  255, 0, 0, 0, 0, 0, NULL },
 { d_ctext_proc,      150, 25, 0,    0, 255, 0, 0, 0, 0, 0, "Input Keys" },
 
 { d_button_proc,     90,  150, 50, 15, 255, 0, 0, D_EXIT, 0, 0, b_ok },
 { d_button_proc,     160, 150, 75, 15, 255, 0, 0, D_EXIT, 0, 0, b_cancel },
 
 { d_text_proc,       10, 45,   0,   0, 255, 0, 0, 0, 0, 0, "L Up:" },
 { d_button_proc,     85, 45,   30,  10, 255, 0, 0, D_EXIT, 0, 0, "   " },
 { d_text_proc,       10, 55,   0,   0, 255, 0, 0, 0, 0, 0, "L Down:" },
 { d_button_proc,     85, 55,   30,  10, 255, 0, 0, D_EXIT, 0, 0, "   " },
 { d_text_proc,       10, 65,   0,   0, 255, 0, 0, 0, 0, 0, "L Left:" },
 { d_button_proc,     85, 65,   30,  10, 255, 0, 0, D_EXIT, 0, 0, "   " },
 { d_text_proc,       10, 75,   0,   0, 255, 0, 0, 0, 0, 0, "L Right:" },
 { d_button_proc,     85, 75,   30,  10, 255, 0, 0, D_EXIT, 0, 0, "   " },

 { d_text_proc,       10, 95,   0,   0, 255, 0, 0, 0, 0, 0, "R Up:" },
 { d_button_proc,     85, 95,   30,  10, 255, 0, 0, D_EXIT, 0, 0, "   " },
 { d_text_proc,       10, 105,   0,   0, 255, 0, 0, 0, 0, 0, "R Down:" },
 { d_button_proc,     85, 105,   30,  10, 255, 0, 0, D_EXIT, 0, 0, "   " },
 { d_text_proc,       10, 115,   0,   0, 255, 0, 0, 0, 0, 0, "R Left:" },
 { d_button_proc,     85, 115,   30,  10, 255, 0, 0, D_EXIT, 0, 0, "   " },
 { d_text_proc,       10, 125,   0,   0, 255, 0, 0, 0, 0, 0, "R Right:" },
 { d_button_proc,     85, 125,   30,  10, 255, 0, 0, D_EXIT, 0, 0, "   " },

 { d_text_proc,       150, 45,   0,   0, 255, 0, 0, 0, 0, 0, "Button A:" },
 { d_button_proc,     245, 45,   30,  10, 255, 0, 0, D_EXIT, 0, 0, "   " },
 { d_text_proc,       150, 55,   0,   0, 255, 0, 0, 0, 0, 0, "Button B:" },
 { d_button_proc,     245, 55,   30,  10, 255, 0, 0, D_EXIT, 0, 0, "   " },
 { d_text_proc,       150, 65,   0,   0, 255, 0, 0, 0, 0, 0, "Start:" },
 { d_button_proc,     245, 65,   30,  10, 255, 0, 0, D_EXIT, 0, 0, "   " },
 { d_text_proc,       150, 75,   0,   0, 255, 0, 0, 0, 0, 0, "Select:" },
 { d_button_proc,     245, 75,   30,  10, 255, 0, 0, D_EXIT, 0, 0, "   " },

 { d_text_proc,       150, 95,   0,   0, 255, 0, 0, 0, 0, 0, "L Trigger:" },
 { d_button_proc,     245, 95,   30,  10, 255, 0, 0, D_EXIT, 0, 0, "   " },
 { d_text_proc,       150, 105,   0,   0, 255, 0, 0, 0, 0, 0, "R Trigger:" },
 { d_button_proc,     245, 105,   30,  10, 255, 0, 0, D_EXIT, 0, 0, "   " },

 { NULL,	      0, 0, 0, 0,       255, 0, 0, 0, 0, 0, NULL }
};




DIALOG options_dialog[] =
{
 { d_shadow_box_proc, 5, 20, 305, 160,  255, 0, 0, 0, 0, 0, NULL },
 { d_ctext_proc,      150, 25, 0,    0, 255, 0, 0, 0, 0, 0, "Emulation Options" },
 
 { d_button_proc,     90,  150, 50, 15, 255, 0, 0, D_EXIT, 0, 0, b_ok },
 { d_button_proc,     160, 150, 75, 15, 255, 0, 0, D_EXIT, 0, 0, b_cancel },
 
 { d_text_proc,       10, 45,   0,   0, 255, 0, 0, 0, 0, 0, "Frameskip:" },
 { d_slider_proc,    100, 45, 100,   8, 255, 0, 0, 0, 9, 0, NULL, NULL },
 
 { d_text_proc,	      10, 65,   0,   0, 255, 0, 0, 0, 0, 0, "Display Mode:" },
 { d_drop_down_proc,  120, 63, 110, 10, 255, 0, 0, 0, 0, 0, list_dspmode },
 
 { d_text_proc,	      10, 85,   0,   0, 255, 0, 0, 0, 0, 0, "Brigtness Hack:" },
 { d_radio_proc,      140, 85,  8,   6, 255, 0, 0, 0, 0, 0, "On" },
 { d_radio_proc,      175, 85,  8,   6, 255, 0, 0, 0, 0, 0, "Off"  },
// { d_radio_proc,      215, 85,  8,   6, 255, 0, 0, 0, 0, 0, "Auto" },

 { d_text_proc,       10, 105,  0,   0, 255, 0, 0, 0, 0, 0, "Palette:" },
 { d_drop_down_proc, 100, 105, 140, 10, 255, 0, 0, 0, 0, 0, list_palette },

 { d_check_proc,      10, 125, 120,  8, 255, 0, 0, 0, 0, 0, "Swap 3D" },
 
 { NULL,	      0, 0, 0, 0,       255, 0, 0, 0, 0, 0, NULL }
};

/* changes the color of the text in the main dialog */


void change_color(int r, int g, int b)
{
   RGB col;

   col.r = r;
   col.g = g;
   col.b = b;

   vsync();

   set_color(254, &col);
}


int StartGUI(int romload)
{
   guiop = GUISTATUS;

   allegro_init();
   install_keyboard();
   install_mouse();
   install_timer();
   set_gfx_mode(tVBOpt.SCR_MODE, tVBOpt.SCR_X, tVBOpt.SCR_Y, 0, 0);
   
   set_window_title(w_title);

   if(romload) { setMenu(1,1,1); }
   else { setMenu(0,0,0); }

   while(1) {
    if(guiop&GUISTATUS) { do_dialog(main_dialog, -1); }
    else { break; }
   }

   if(guiop&AKILL) { allegro_exit(); }
   if(guiop&GUIEXIT) { return 1; }   
   if(guiop&GUISTATUS) { return 2; }
   if(guiop&VBRESET) { return 2; }
   else { return 0; }
}

void initAllegro(void)
{
  /* printf("running allegro_init()\n");
   allegro_init();
   printf("running install_keyboard()\n");
   install_keyboard();
   printf("running install_mouse()\n");
   install_timer();
   install_mouse();
   printf("running install_timer()\n");
//   install_timer();*/
   set_window_title(w_title);
}

void setMenu(int a, int b, int c) {           
 if(a==0) { file_menu[1].flags = D_DISABLED; }
 if(a==1) { file_menu[1].flags = 0; }

 if(b==0) { main_menu[2].flags = D_DISABLED; }
 if(b==1) { main_menu[2].flags = 0; }

 if(c==0) { main_menu[3].flags = D_DISABLED; }
 if(c==1) { main_menu[3].flags = 0; }
}

void disableMenus(void) {
 file_menu[1].flags = D_DISABLED;
 main_menu[2].flags = D_DISABLED;
 main_menu[3].flags = D_DISABLED;
}

void writeValue(int Fvalue) {
   if(Fvalue==0) { fprintf(optionsFile, "0000\n"); }
   if((Fvalue>0) && (Fvalue<10)) { fprintf(optionsFile, "000%d\n", Fvalue); }
   if((Fvalue>=10) && (Fvalue<100)) { fprintf(optionsFile, "00%d\n", Fvalue); }
   if((Fvalue>=100) && (Fvalue<1000)) { fprintf(optionsFile, "0%d\n", Fvalue); }
   if(Fvalue>=1000) { fprintf(optionsFile, "%d\n", Fvalue); }
}

int writeHWORD(HWORD data) {
	fputc((char)((data & 0xFF00)>>8), stateFile);
	fputc((char)(data & 0x00FF), stateFile);
	return 0;
}

HWORD readHWORD(void) {
	HWORD returnval;
	
	returnval = fgetc(stateFile)<<8;
	returnval = returnval + fgetc(stateFile);

	return returnval;
}
			
void doOptions(void) {
	options_dialog[5].d2 = tVBOpt.FRMSKIP;
	options_dialog[7].d2 = tVBOpt.DSPMODE;
	options_dialog[14].flags = (tVBOpt.DSPSWAP * 2);

	if(tVBOpt.FIXPAL==0) { options_dialog[9].flags = 0;
		               options_dialog[10].flags = 2;
			       options_dialog[11].flags = 0; }
	if(tVBOpt.FIXPAL==1) { options_dialog[9].flags = 2;
		               options_dialog[10].flags = 0;
			       options_dialog[11].flags = 0; }
	if(tVBOpt.FIXPAL==2) { options_dialog[9].flags = 0;
		               options_dialog[10].flags = 0;
			       options_dialog[11].flags = 2; }


	do_dialog(options_dialog, -1);
	 
	
	//Did they click OK?
	if(options_dialog[2].flags==5) {
	  tVBOpt.FRMSKIP = options_dialog[5].d2;
	  tVBOpt.DSPMODE = options_dialog[7].d2;
	  if(options_dialog[9].flags) { tVBOpt.FIXPAL = 1; }
	  if(options_dialog[10].flags) { tVBOpt.FIXPAL = 0; }
	  if(options_dialog[11].flags) { printf("TODO: Auto Brightness fix\n"); }
	  if(options_dialog[14].flags) { tVBOpt.DSPSWAP = 1; }
	  else { tVBOpt.DSPSWAP = 0; }
	}

	//Clean up our leftover window image by telling other dialogs to redraw
	broadcast_dialog_message(MSG_DRAW, 0);
}

void doKeys(void) {
     int i=0,j=0,k=0,loop=1;
     int tempkey[14];

     //Copy vbkey to tempkey
     for(i=0;i<14;i++) { tempkey[i] = vbkey[i]; }

     while(loop) {
        //Set window caption text to appropriate key
        for(i=0;i<14;i++) { input_dialog[i*2+5].dp = keynames[tempkey[i]]; }

        do_dialog(input_dialog, -1);

        //Check if any buttons were pressed
        for(i=0;i<14;i++) {
           if(input_dialog[i*2+5].flags==5) {
              j=0;
              while(!j) {
                 //See if any keys were pressed
                 for(k=1;k<115;k++) {
                    if(key[k]) {
                       while(key[k]) { } //Wait for release
                       tempkey[i] = k;
                       j = 1;
                       k = 115;
                    }
                  }
               }
            }
        }

        //Did they click CANCEL?
        if(input_dialog[3].flags==5) { loop = 0; }

	//Did they click OK?
        if(input_dialog[2].flags==5) {
          //Copy tempkey to vbkey
          for(i=0;i<14;i++) { vbkey[i] = tempkey[i]; }
          loop = 0;
	}

    }
        //Clean up our leftover window image by telling other dialogs to redraw
	broadcast_dialog_message(MSG_DRAW, 0);
}



/*The following function is by Revin Guillen
Check out his awesome Allegro GUI tutorial site at http://students.washington.edu/revin/gui
I figured I might as well use it since it's pointless to reinvent the wheel, right? */

int d_drop_down_proc(int msg, DIALOG *d, int c)
{
  int num_items = 0;
  char **items = d->dp;
  int fgcol, bgcol;
  int old_x=-1, old_y=-1;
  int mx, my;
  int bot;
  int text_y, ry;
  int ht;
  int i;

  /* get the number of items */
  if (items != NULL) {
    while (items[num_items++] != NULL)
      ;
  }
  num_items--;

  /* clamp the value of the selection index */
  if (d->d1 >= num_items)
    d->d1 = num_items - 1;

  ht = text_height(font) + 4;

  bot = d->y + d->h + (ht*num_items);

  fgcol = (d->flags & D_DISABLED) ? gui_mg_color : d->fg;
  bgcol = d->bg;

  switch (msg)
  {
  case MSG_DRAW:

    if ( !(d->flags & D_HIDDEN) ) {

      rect(screen, d->x, d->y,
          d->x+d->w, d->y+d->h, fgcol);
      
      /* invert the colors */
      if (d->flags & D_GOTFOCUS) {
        i = fgcol;
        fgcol = bgcol;
        bgcol = i;
      }

      rectfill(screen, d->x+1, d->y+1, d->x+d->w-1, d->y+d->h-1, bgcol);

      text_mode(-1);
      text_y = d->y+(d->h/2)-(text_height(font)/2)+1;
      gui_textout(screen, items[d->d1], d->x+6, text_y, fgcol, 0);

      /* if we've got the focus */
      if (d->flags & D_GOTFOCUS) {
        for (i=d->x+2; i<d->x+d->w; i+=2) {
          putpixel(screen, i, d->y+2, fgcol);
          putpixel(screen, i, d->y+d->h-2, fgcol);
        }
        for (i=d->y+2; i<d->y+d->h; i+=2) {
          putpixel(screen, d->x+2, i, fgcol);
          putpixel(screen, d->x+d->w-2, i, fgcol);
        }
      }

      /* restore the colors */
      if (d->flags & D_GOTFOCUS) {
        i = fgcol;
        fgcol = bgcol;
        bgcol = i;
      }

      /* if we're dropped down */
      if (d->flags & D_SELECTED) {
        rect(screen, d->x, d->y+d->h, d->x+d->w, bot, fgcol);
        rectfill(screen, d->x+1, d->y+d->h+1, d->x+d->w-1, bot-1, bgcol);

        for (i=0; i<num_items; i++) {
          text_y = d->y+d->h+(i*ht)+3;

          if (i == d->d2) {
            ry = d->y+d->h+(i*ht);
            rectfill(screen, d->x+1, ry, d->x+d->w-1, ry+ht, fgcol);
            gui_textout(screen, items[i], d->x+4, text_y, bgcol, 0);
          } else {
            gui_textout(screen, items[i], d->x+4, text_y, fgcol, 0);
          }
        }
      }

    }
    break;

  case MSG_CLICK:

    if ( !(d->flags & D_HIDDEN) && !(d->flags & D_DISABLED) ) {

      d->d2 = -10000; /* below lowest possible */
      
      /* only works with the left mouse button */
      while (gui_mouse_b() & 0x01) {

        mx = gui_mouse_x();
        my = gui_mouse_y();

        if (((mx != old_x) || (my != old_y)) &&
           ((mx > d->x) && (mx < d->x+d->w) &&
            (my > d->y) && (my < bot ))) {

          old_x = mx;
          old_y = my;

          if (d->d2 != ((my-d->y-d->h)/ht)) {

            if (d->flags & D_SELECTED) {
              if (my >= d->y+d->h) {
                d->d2 = ((my-d->y-d->h)/ht);
              }
            } else {
              d->d2 = d->d1;
            }
            
            /* signals a dropped-down state */
            d->flags |= D_SELECTED;

            scare_mouse();

            /* redraw in the dropped-down position */
            SEND_MESSAGE(d, MSG_DRAW, 0);

            unscare_mouse();
          }

        }
      }

      /* return to non-dropped-down state */
      d->flags &= ~D_SELECTED;

      /* finalize the selection */
      if ((mx > d->x) && (mx < d->x+d->w) && (my > d->y) && (my < bot ))
        d->d1 = d->d2;

      return D_REDRAW;

    }
    break;

  case MSG_CHAR:

    if ( !(d->flags & D_HIDDEN) && !(d->flags & D_DISABLED)) {

      i=FALSE;

      if ((c >> 8) == KEY_UP) {
        if (d->d1 > 0)
          d->d1--;
        i=TRUE;
      } else if ((c >> 8) == KEY_DOWN) {
        if (d->d1 < num_items)
          d->d1++;
        i=TRUE;
      } else if ((c >> 8) == KEY_HOME) {
        d->d1 = 0;
        i=TRUE;
      } else if ((c >> 8) == KEY_END) {
        d->d1 = num_items;
        i=TRUE;
      }

      d->d2 = d->d1;
      scare_mouse();
      SEND_MESSAGE(d, MSG_DRAW, 0);
      unscare_mouse();

      if (i)
        return D_USED_CHAR;

    }
    break;

  case MSG_WANTFOCUS:

    return D_WANTFOCUS;
  }

  return D_O_K;
}
  

